/****************************************************************************************
    Copyright 2004 uja
    Copyright 2004 Trolltech (Qt3)

    This file is part of Edelsteine.
*****************************************************************************************/

// Hauptfenster Edelsteine

#include "window.h"

window::window(QWidget *parent,char* name): QHBox(parent,name)
{ 
  this->setMargin(16);
  this->setSpacing(8);
  this->setPaletteBackgroundColor(BACKGR0);
  this->setCaption(TITEL);  
  this->setMaximumSize(WIN_BMAX,WIN_HMAX);
  this->setMinimumSize(WIN_BMIN,WIN_HMIN);

// Feld links: Spielwiese und Padding nach unten
  QVBox* p_spalte0=new QVBox(this);
  p_spalte0->setMargin(DX);
  p_spalte0->setBackgroundColor(BACKGR1);
  my_view=new viewport(p_spalte0,"playfield"); // QCanvasView-Variante
  
  // naechste Spalte:
  QVBox* p_spalte1=new QVBox(this);
  p_spalte1->setMargin(8);             // Container fuer Block Ueberschrift/Anzeigen und Canvas 
  p_spalte1->setSpacing(8); 
  // Ueberschrift als Pixmap
  QLabel* p_ue =new QLabel(p_spalte1);
  p_ue->setPixmap(QPixmap(TITELBILD)); 

  // Anzeigetafel:
  QGrid* p_anzeigen=new QGrid(2,p_spalte1,"anzeigen");  // Anzeigetafel
  p_anzeigen->setMinimumSize(192,96);
  p_anzeigen->setFrameShadow(Sunken);
  p_anzeigen->setFrameShape(Box);
  p_anzeigen->setMargin(16);
  p_anzeigen->setPaletteBackgroundPixmap(QPixmap(BACKPIX2));
  p_anzeigen->setPaletteForegroundColor(COLOR2);
  QLabel* p_llevel =new QLabel(p_anzeigen); p_level  =new QLabel(p_anzeigen);    
  QLabel* p_lzeit  =new QLabel(p_anzeigen); p_zeit   =new QLabel(p_anzeigen);  
  QLabel* p_lpunkte=new QLabel(p_anzeigen); p_punkte =new QLabel(p_anzeigen); 

  // Ticker:
  QHBox* p_ticker=new QHBox(p_spalte1,"timeticker"); 
  for (int i=0; i<ZEIT0; i++) p_tick[i]=new QLabel(p_ticker); 
 
  QLabel* p_zero1=new QLabel(p_spalte1);
  p_spalte1->setStretchFactor(p_anzeigen,0);
  p_spalte1->setStretchFactor(p_zero1,10);
// alles weitere (HSC) haengt sich rechts dran

// Daten einfuellen:  
  p_llevel ->setText(_LLEVEL); p_level->setText("Eazy does it!");
  p_lzeit  ->setText(_LTIME);  p_zeit->setNum(999);
  p_lpunkte->setText(_LSCORE); p_punkte->setNum(0);

}

void window::set_punkte(int p)    { p_punkte->setNum(p); }
void window::set_zeit(int p)      { p_zeit->setNum(p); }
void window::set_level(QString p) { p_level->setText(p); }

void window::set_ticker(int p)
{
  for (int i=0; i<ZEIT0; i++) 
   if (i<p) p_tick[i]->setPixmap(QPixmap(TIMEDOT_ON)); else  p_tick[i]->setPixmap(QPixmap(TIMEDOT_OFF));
  // if (i<p) p_tick[i]->setText("o"); else p_tick[i]->setText(" ");
}
